########################################
### Image ##############################
########################################

image:
  name: aztek/awscli
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

########################################
### Prerequisites ######################
########################################

stages:
  - validate
  - deploy
  - destroy

before_script:
  - aws --version
  - find . -name '*.yml' -not -path "*gitlab*" > /tmp/yaml.files

########################################
### Validate ###########################
########################################

validate:
  stage: validate
  script:
    - |
        while read -r file; do
            aws cloudformation validate-template \
                --template-body "file://${file##*/}"
        done < /tmp/yaml.files
  only:
    changes:
      - "*.yml"
  except:
    changes:
      - .gitlab-ci.yml

########################################
### Deploy #############################
########################################

deploy:
  stage: deploy
  script:
    - |
        while read -r file; do
            filename="${file##*/}"
            creation_status="$(
                aws cloudformation describe-stacks \
                    --stack-name "${filename%%.*}" 2> /dev/null
            )"

            if [[ -n "$creation_status" ]]; then
                action='update-stack'
            else
                action='create-stack'
            fi

            aws cloudformation "$action" \
                --stack-name "${filename%%.*}" \
                --template-body "file://${filename}" \
                --parameters "ParameterKey=Webhook,ParameterValue=${WEBHOOK}" \
                --capabilities "CAPABILITY_IAM"
        done < /tmp/yaml.files
  dependencies:
    - validate
  only:
    changes:
      - "*.yml"
  except:
    changes:
      - .gitlab-ci.yml

########################################
### Destroy ############################
########################################

destroy:
  stage: destroy
  script:
    - |
        while read -r file; do
            filename="${file##*/}"
            aws cloudformation delete-stack \
                --stack-name "${filename%%.*}"
        done < /tmp/yaml.files
  dependencies:
    - deploy
  only:
    - master
  when: manual

